-- table to maintain session data for login

CREATE TABLE IF NOT EXISTS "umc_login_sessions" () WITH (OIDS=FALSE);

ALTER TABLE "umc_login_sessions" ADD COLUMN IF NOT EXISTS "sid" varchar NOT NULL COLLATE "default";

ALTER TABLE "umc_login_sessions" ADD COLUMN IF NOT EXISTS "sess" json NOT NULL;

ALTER TABLE "umc_login_sessions" ADD COLUMN IF NOT EXISTS "expire" timestamp(6) NOT NULL;

ALTER TABLE "umc_login_sessions" ADD COLUMN IF NOT EXISTS "user_id" varchar;

ALTER TABLE "umc_login_sessions" ADD CONSTRAINT "session_pkey" PRIMARY KEY ("sid") NOT DEFERRABLE INITIALLY IMMEDIATE;

CREATE INDEX IF NOT EXISTS "IDX_session_expire" ON "umc_login_sessions" ("expire");

-- table to log user actions

CREATE TABLE IF NOT EXISTS "action" () WITH (OIDS=FALSE);

ALTER TABLE "action" ADD COLUMN IF NOT EXISTS "id" uuid NOT NULL DEFAULT gen_random_uuid ();

ALTER TABLE "action" ADD COLUMN IF NOT EXISTS "timestamp" timestamp(6) NOT NULL;

ALTER TABLE "action" ADD COLUMN IF NOT EXISTS "user" varchar NOT NULL COLLATE "default";

ALTER TABLE "action" ADD COLUMN IF NOT EXISTS "api" varchar NOT NULL;

ALTER TABLE "action" ADD COLUMN IF NOT EXISTS "operation" varchar NOT NULL;

ALTER TABLE "action" ADD COLUMN IF NOT EXISTS "params" json NOT NULL;

ALTER TABLE "action" ADD COLUMN IF NOT EXISTS "status" varchar NOT NULL COLLATE "default";

ALTER TABLE "action" ADD CONSTRAINT "id_pkey" PRIMARY KEY ("id") NOT DEFERRABLE INITIALLY IMMEDIATE;

CREATE INDEX IF NOT EXISTS "IDX_user" ON "action" ("user");

-- a lookup table for edir tree-name resolution

CREATE TABLE IF NOT EXISTS "tree" () WITH (OIDS=FALSE);

ALTER TABLE "tree" ADD COLUMN IF NOT EXISTS "name" varchar NOT NULL;

ALTER TABLE "tree" ADD COLUMN IF NOT EXISTS "network_interfaces" varchar[] NOT NULL;

ALTER TABLE "tree" ADD CONSTRAINT "name_pkey" PRIMARY KEY ("name") NOT DEFERRABLE INITIALLY IMMEDIATE;
